#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <net/if.h>
#include <fcntl.h>
#include <string.h>
#include <limits.h>
#include <ifaddrs.h>
#include <unistd.h>

#include "netmon_std.h"

/* network monitor
 * Monitors the bytes of traffic on a network device
 * 2006-05-14 ed AT s5h DOT net
 * Use at your own risk. Author not responsible for use.
 * $Id: netmon_bsd.c 11889 2013-05-29 20:50:07Z ed $
 *
 * Updates at http://www.s5h.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */

struct interface_line *getinterfaces() {
	struct ifaddrs *ifa;
	struct ifaddrs *pifaddrs;
	struct if_data *idata;
	struct interface_line *pil, *il,*last;

	if( getifaddrs( &ifa ) < 0 ) {
		fprintf( stderr, "Cannot get the interface list\n" );
		exit( EXIT_FAILURE );
	}
	
	il = pil = NULL;

	for( pifaddrs = ifa ; pifaddrs ; pifaddrs = pifaddrs->ifa_next ) {
		idata = pifaddrs->ifa_data;
		
		if( idata != NULL && idata->ifi_ibytes != 0 ) {
			il = (struct interface_line*)malloc( 
				sizeof( struct interface_line ) );

			strncpy( il->name, pifaddrs->ifa_name, 20 );
			il->name[20] = '\0';
			il->ibytes = idata->ifi_ibytes;
			il->obytes = idata->ifi_obytes;
			il->ipackets = idata->ifi_ipackets;
			il->opackets = idata->ifi_opackets;
			il->ierr = idata->ifi_ierrors;
			il->oerr = idata->ifi_oerrors;
			il->idrop = idata->ifi_iqdrops;
			il->next = NULL;

			if( pil == NULL ) {
				pil = il;
				last = pil;
			}
			else {
				last->next = il;
				last = il;
			}
		}
	}
	
	freeifaddrs( ifa );
	return( pil );
}


